#!/usr/bin/python

#####################################################
# 
# Ian York
# Jan/Feb 2007 
# 
######################################################

import sys
#print "PYTHON IS" , sys.version 
#if not hasattr(sys, "frozen"):
#    import wxversion
#    wxversion.select("2.8.7")  #Change this as we update wxPython 
#sys.path.insert(0, "/usr/local/lib/wxPython-unicode-2.8.8.1")
import  wx  
#print "WX IS " , wx.__version__
import  wx.lib.colourselect as  csel
import  wx.lib.flatnotebook as fnb
import  wx.lib.mixins.listctrl  as  listmix
from    wx.lib.wordwrap import wordwrap 
import  wx.grid as gridlib
import  colorsys

from math import pi, cos, sin, radians, degrees , sqrt, atan2, ceil
import os
import time
import copy
import re 
import unicodedata
import random

from xml.etree      import ElementTree as ET  
from elementtree.SimpleXMLWriter import XMLWriter   
#xml.parsers.expat to handle ET's ExpatError if can't read a non-XML file
import xml.parsers.expat as expat
import mx.UID 
 
from XPDialogs      import * 
from XPCanvas       import *
from XPListViews    import *  
from XPFeatures     import *
from XPBioMethods   import *

LIGHT_BLUE          = wx.Colour(237,243,254,255)   #(185,211,238,64) 
LIGHT_RED           = wx.Colour(255, 0, 0, 64)
LIGHT_GREEN         = wx.Colour(0, 255, 0, 64)
LIGHT_GREY          = wx.Colour(236,236,236,255)
LINE_GREY           = wx.Colour(190,190,190,255)
DARK_GREY           = wx.Colour(128,128,128,255)
DARKER_GREY         = wx.Colour(64,64,64,255)
TRANSPARENT_RED     = wx.Colour(255,0,0,32)

appPath = sys.argv[0]
pathToResources = os.path.split(appPath)[0] 
        
#----------------------------------------------------------------------- 
#Define TabView(wx.Notebook)  NOTEBOOK STYLE

class TabView(wx.Notebook):
    def __init__(self,parent, id=wx.ID_ANY, pos=wx.DefaultPosition, size=wx.DefaultSize,style=wx.NB_BOTTOM):
        wx.Notebook.__init__(self, parent, id, pos, size,style) 
        self.frame = parent
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGED, self.onPageChanged)
        
    def onPageChanged(self,evt): 
        xpcanvas = self.GetCurrentPage()  
        self.frame.toggleLinearMenu()
        
#----------------------------------------------------------------------- 
#Define TabView(wx.FlatNotebook)  FLATNOTEBOOK STYLE

class FlatTabView(fnb.FlatNotebook):
    def __init__(self, parent, id=wx.ID_ANY):
        fnb.FlatNotebook.__init__(self, parent, id, style=fnb.FNB_BOTTOM|fnb.FNB_NO_NAV_BUTTONS|fnb.FNB_VC71|fnb.FNB_X_ON_TAB) 
        self.SetNonActiveTabTextColour(DARKER_GREY)
        self.frame = parent
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGED, self.onPageChanged)
        
    def onPageChanged(self,evt):
        tabViewIndex = evt.GetSelection() 
        xpcanvas = self.GetPage(tabViewIndex)  
        (scaleX, scaleY) = xpcanvas.getScale()
        self.frame.setScaleDisplay(scaleX)
        self.frame.toggleLinearMenu() 
        
#----------------------------------------------------------------------
# BaseFrame mainly for menu handlers, reading/writing files, and a few general functions
        
class BaseFrame(wx.Frame):
    def __init__(self,parent=None, id=wx.ID_ANY, title="XPlasMap", pos=(100,-1), size=(825,850)) :
        wx.Frame.__init__(self, parent, id, title, pos, size)     

        self.SetName("BaseFrame")
        self.size = size 
          
        self.readPreferences()   
        self.defaultFont = wx.Font( pointSize=int(self.preferences["FontPointSize"]), 
                                    style=int(self.preferences["FontStyle"] ), 
                                    weight=int(self.preferences["FontWeight"] ), 
                                    face=self.preferences["FontFaceName"],
                                    family=wx.FONTFAMILY_DEFAULT  ) 
            
        self.useToolBar = self.preferences['UseToolBar']
        display = wx.Display(0) 
        screenArea = display.GetClientArea()
        #bounding area = (topLeftX,topleftY,bottomRightX, bottomRightY) 
        if screenArea[2] - screenArea[0] > 825:
            self.windowWidth = 825
        else:
            self.windowWidth = screenArea[2] - screenArea[0]
        if screenArea[3] - screenArea[1] > 850:
            self.windowHeight = 850
        else:
            self.windowHeight = screenArea[3] - screenArea[1]
        #Allow for the toolbar when setting height
        if self.preferences['UseToolBar']:
            self.SetSize( (self.windowWidth,self.windowHeight-50) ) 
        else:
            self.SetSize( (self.windowWidth,self.windowHeight) ) 
           
        self.tabView                        = FlatTabView(self) 
        
        self.unsavedChangesDict             = {} 
        self.printData                      = False 
        self.fragment                       = False
        self.fragmentGenes                  = False
        self.fragmentMCSList                = False 
        self.fragmentEnzymes                = False 
        self.fragmentComments               = False  
        
        #Menu and toobar IDs ####################################### 
        self.setMenuIDs()
        
        #StatusBar for explanatory text ############################
        self.statusBar = wx.StatusBar(parent=self,id=wx.ID_ANY)
        self.SetStatusBar(self.statusBar)  
        
        # Depending on Preferences, either set up a toolbar, 
        # or  put the scale spinctrl in the statusbar
        if self.preferences['UseToolBar']:
            self.setupToolBar()
        else: 
            self.statusBar.SetFieldsCount(3) 
            self.statusBar.SetStatusWidths([50, 75, -10])   
            self.statusBar.SetStatusText("Scale:", 0) 
            self.scaleSpinCtrl = wx.SpinCtrl(self.statusBar, wx.ID_ANY, value="100", min=10, max=1000, style=wx.SP_ARROW_KEYS  ) 
            self.SetStatusBar(self.statusBar)        
            rect = self.statusBar.GetFieldRect(1)
            self.scaleSpinCtrl.SetPosition((rect.x+2, rect.y+2))
            self.scaleSpinCtrl.SetSize((rect.width-4, rect.height-4))
     
        #self.sizeChanged for the scale spinCtrl
        self.sizeChanged = False   
        
        #set up menus ##############################################
        self.menubar    = wx.MenuBar() 
        menu1           = wx.Menu()
        #Auto-insertion into the System menu
        menu1.Append(wx.ID_ABOUT,                   "&About XPlasMap")
        menu1.Append(wx.ID_EXIT,                    "&Quit\tCtrl+Q") 
        menu1.Append(wx.ID_PREFERENCES,             "&Preferences\tCtrl+,")
        
        menu1.Append(self.openMenuID,               "&Open\tCtrl+O")
        #set up Open Recent menu
        self.recentFilesIdByFile                    = {} 
        self.recentFilesFileById                    = {}
        self.recentFilesMenu                        = wx.Menu() 
        self.setUpRecentFiles()
        
        self.recentFilesMenu.AppendSeparator()   
        self.recentFilesMenu.Append(self.clearRecentMenuID, "Clear recent files")  
        menu1.AppendMenu(self.openRecentMenuID,     "&Open Recent", self.recentFilesMenu)
        self.importMenu                             = wx.Menu()
        self.importMenu.Append(self.importFromGBMenuID,     "&from Genbank (.gb files)") 
        self.importMenu.Append(self.importFromFastAMenuID,  "&from FastA or text") 
        self.importMenu.Append(self.importFromEmbossID,     "&from EMBOSS") 
         
        menu1.AppendMenu(self.importMenuID,         "&Import",          self.importMenu)
        menu1.AppendSeparator()
        
        menu1.Append(self.closeMenuID,              "&Close page\tCtrl+W")
        menu1.AppendSeparator()
        menu1.Append(self.saveMenuID,               "&Save\tCtrl+S") 
        menu1.Append(self.saveAsMenuID,             "&Save as\tCtrl+Shift+S")  
        menu1.Append(self.exportMenuID,             "&Export") 
        menu1.AppendSeparator()
        menu1.Append(self.pageSetupMenuID,          "&Page setup")
        menu1.Append(self.printMenuID,              "&Print\tCtrl+P") 
        self.menubar.Append(menu1, "&File")
        
        menu2 = wx.Menu()
        menu2.Append(self.undoMenuID,               "&Undo\tCtrl+Z" ) 
        menu2.AppendSeparator() 
        menu2.Append(self.editPlasmidMenuID,        "&Plasmid info\tCtrl+I")
        menu2.AppendSeparator() 
        menu2.Append(self.deleteMenuID,             "&Delete selected")
        menu2.Append(self.editSelectedMenuID,       "&Edit selected\tCtrl+E")
        menu2.AppendSeparator()  
        menu2.Append(self.cutFragmentMenuID,        "&Cut fragment\tCtrl+X")  
        menu2.Append(self.copyFragmentMenuID,       "&Copy fragment\tCtrl+C") 
        menu2.Append(self.insertFragmentMenuID,     "&Insert fragment\tCtrl+V")  
        menu2.AppendSeparator() 
        menu2.Append(self.enzymesToMCSMenuID,       "&MCS <> enzymes")
        menu2.AppendSeparator() 
        menu2.Append(self.fontMenuID,               "&Set font")
        self.menubar.Append(menu2,"&Edit")  
        
        menu3 = wx.Menu() 
        menu3.Append(self.newGeneMenuID,            "&New gene\tCtrl+G")
        menu3.Append(self.newMCSMenuID,             "&New multiple cloning site\tCtrl+Shift+M")
        menu3.Append(self.newEnzymeMenuID,          "&New restriction site\tCtrl+R") 
        #menu3.AppendSeparator() 
        #menu3.Append(self.newBatchGeneMenueID,      "&Batch enter genes")
        #menu3.Append(self.newBatchEnzymeMenuID,     "&Batch enter restriction sites")
        menu3.AppendSeparator() 
        menu3.Append(self.addTextMenuID,            "&Add text\tCtrl+T") 
        menu3.Append(self.addArrowMenuID,           "&Add arrow") 
        menu3.Append(self.addRectangleMenuID,       "&Add box") 
        menu3.Append(self.addCircleMenuID,          "&Add circle")
        self.menubar.Append(menu3,"&Features") 
        
        menu5 = wx.Menu()
        menu5.Append(self.newPlasmidMenuID,         "&New circular plasmid\tCtrl+N")
        menu5.Append(self.newLinearMenuID,          "&New linear DNA\tCtrl+Shift+N") 
        menu5.AppendSeparator()
        self.positionMenu                           = wx.Menu()
        self.positionMenu.Append(self.positionEnzymesMenuID,        "&Enzymes") 
        self.positionMenu.Append(self.positionGenesMenuID,          "&Gene text")   
        menu5.AppendMenu(self.positionMenuID,       "&Auto-position",               self.positionMenu)  
        self.resetPositionsMenu                     = wx.Menu()
        self.resetPositionsMenu.Append(self.resetEnzymesMenuID,     "&Enzymes") 
        self.resetPositionsMenu.Append(self.resetGenesMenuID,       "&Gene text") 
        menu5.AppendMenu(self.resetMenuID,          "&Reset positions",             self.resetPositionsMenu)  
        menu5.AppendSeparator()  
        menu5.Append(self.reverseLinearMenuID,      "&Draw antiparallel")
        menu5.Append(self.circularizeMenuID,        "&Linear <> Circular")
        menu5.AppendSeparator()  
        menu5.Append(self.viewAllAsListMenuID,      "&List view\tCtrl+L")  
        self.menubar.Append(menu5,"&Maps")  
        
        self.SetMenuBar(self.menubar)   
        
        if len(sys.argv) < 2:
            self.enableMenuItems(xpcanvas=None, enable=False)
            
        #Bind menu events ##############################################
        #File menu events
        self.Bind(wx.EVT_MENU,  self.onAbout,           id=wx.ID_ABOUT)
        self.Bind(wx.EVT_MENU,  self.onQuit,            id=wx.ID_EXIT)
        self.Bind(wx.EVT_MENU,  self.onPreferences,     id=wx.ID_PREFERENCES)
        
        self.Bind(wx.EVT_MENU,  self.onOpenFile,        id=self.openMenuID)
        self.Bind(wx.EVT_MENU,  self.importFromGB,      id=self.importFromGBMenuID)
        self.Bind(wx.EVT_MENU,  self.importFromFastA,   id=self.importFromFastAMenuID)
        self.Bind(wx.EVT_MENU,  self.importFromEmboss,  id=self.importFromEmbossID)
        
        for file in self.preferences['RecentFiles']: 
            self.Bind(wx.EVT_MENU,  self.onRecentFile,  id=self.recentFilesIdByFile[file])
        self.Bind(wx.EVT_MENU,  self.clearRecentFiles,  id=self.clearRecentMenuID)
        self.Bind(wx.EVT_MENU,  self.onClosePage,       id=self.closeMenuID)  
        self.Bind(wx.EVT_MENU,  self.onSaveFile,        id=self.saveMenuID)
        self.Bind(wx.EVT_MENU,  self.onSaveAs,          id=self.saveAsMenuID) 
        self.Bind(wx.EVT_MENU,  self.onExportMenu,      id=self.exportMenuID) 
        self.Bind(wx.EVT_MENU,  self.onPageSetup,       id=self.pageSetupMenuID)
        self.Bind(wx.EVT_MENU,  self.onPrint,           id=self.printMenuID)
         
        #Edit menu events
        self.Bind(wx.EVT_MENU,  self.onUndo,            id=self.undoMenuID)  
        self.Bind(wx.EVT_MENU,  self.onEditPlasmid,     id=self.editPlasmidMenuID) 
        self.Bind(wx.EVT_MENU,  self.onDeleteSelected,  id=self.deleteMenuID)
        self.Bind(wx.EVT_MENU,  self.onEditSelected,    id=self.editSelectedMenuID)
        self.Bind(wx.EVT_MENU,  self.onEnzymesToMCS,    id=self.enzymesToMCSMenuID) 
        self.Bind(wx.EVT_MENU,  self.onSetFont,         id=self.fontMenuID)
        
        #Feature menu events
        self.Bind(wx.EVT_MENU,  self.onAddGene,         id=self.newGeneMenuID)
        self.Bind(wx.EVT_MENU,  self.onAddMCS,          id=self.newMCSMenuID)
        self.Bind(wx.EVT_MENU,  self.onAddEnzyme,       id=self.newEnzymeMenuID)   
        #self.Bind(wx.EVT_MENU,  self.onBatchEnzymes,    id=self.newBatchEnzymeMenuID)
        #self.Bind(wx.EVT_MENU,  self.onBatchGenes,      id=self.newBatchGeneMenueID) 
        self.Bind(wx.EVT_MENU,  self.onDeleteMenu,      id=self.cutFragmentMenuID)  
        self.Bind(wx.EVT_MENU,  self.copyFragmentMenu,  id=self.copyFragmentMenuID) 
        self.Bind(wx.EVT_MENU,  self.onInsertMenu,      id=self.insertFragmentMenuID)
        self.Bind(wx.EVT_MENU,  self.onAddText,         id=self.addTextMenuID) 
        self.Bind(wx.EVT_MENU,  self.onAddArrowMenu,    id=self.addArrowMenuID ) 
        self.Bind(wx.EVT_MENU,  self.onAddRectangleMenu,id=self.addRectangleMenuID ) 
        self.Bind(wx.EVT_MENU,  self.onAddCircleMenu,   id=self.addCircleMenuID)
        
        #Plasmid menu events
        self.Bind(wx.EVT_MENU,  self.getNewPlasmidInfo, id=self.newPlasmidMenuID)
        self.Bind(wx.EVT_MENU,  self.getNewPlasmidInfo, id=self.newLinearMenuID)
        self.Bind(wx.EVT_MENU,  self.onReverseLinear,   id=self.reverseLinearMenuID)
        self.Bind(wx.EVT_MENU,  self.onCircularize,     id=self.circularizeMenuID) 
        self.Bind(wx.EVT_MENU,  self.onPositionEnzymes, id=self.positionEnzymesMenuID) 
        self.Bind(wx.EVT_MENU,  self.onPositionGenes,   id=self.positionGenesMenuID)
        self.Bind(wx.EVT_MENU,  self.onResetEnzymes,    id=self.resetEnzymesMenuID) 
        self.Bind(wx.EVT_MENU,  self.onResetGenes,      id=self.resetGenesMenuID)    
        self.Bind(wx.EVT_MENU,  self.makeNewListctrl,   id=self.viewAllAsListMenuID) 
        
        #other bindings
        self.Bind(wx.EVT_CLOSE,         self.onClosePage)
        self.Bind(wx.EVT_ACTIVATE,      self.onActivate) 
        self.Bind(wx.EVT_SPINCTRL,      self.onSetScale) 
        
        self.Bind(wx.EVT_CHAR,          self.onKeyPressed)
        
        if len(sys.argv) > 1:
            for fileName in sys.argv[1:]:
                self.openXMLFile(fileName)
  
#-----------------------------------------------------------------------

    def onKeyPressed(self, evt): 
        # Delete of backspace key deletes fragment or element depending on what's selected 
        if evt.GetKeyCode() == wx.WXK_BACK or evt.GetKeyCode() == wx.WXK_DELETE: 
            try:
                xpcanvas = self.tabView.GetCurrentPage()
                if xpcanvas.selectStart and xpcanvas.selectEnd:
                    xpcanvas.backupsForUndo()
                    xpcanvas.selected = False
                    fragment = Fragment(xpcanvas)  
                    fragment.deleteFragment(xpcanvas.selectStart, xpcanvas.selectEnd, orientation="Clockwise")
                    xpcanvas.highlight.flash()
                    self.toggleUndoMenu() 
                else:
                    xpcanvas.deleteSelected()
                    self.toggleUndoMenu() 
            except:
                pass
                #raise

    def onActivate(self, evt):
        self.setActivated(self)
        evt.Skip()
        
    def setActivated(self, activeWindow):
        self.activeWindow = activeWindow

    def readPreferences(self): 
        #read preferences 
        standardPaths               = wx.StandardPaths.Get()
        pathToPreferences           = standardPaths.GetUserConfigDir()
        self.preferenceFile         = os.path.join(pathToPreferences, "XPlasMap Preferences" )
        self.preferences            = {} 
         
        # Start with everything set to default 
        self.preferences['RecentFiles']             = []
        self.preferences['ExportResolution']        = 5.0
        self.preferences['MinimumORFLength']        = 100 
        self.preferences['IdentifyOrfText']         = True 
        self.preferences['IdentifyOrfGeneBank']     = False
        self.preferences['StartWithATG']            = True 
        self.preferences['FontFaceName']            = 'Arial'
        self.preferences['FontPointSize']           = 12
        self.preferences['FontWeight']              = wx.FONTWEIGHT_NORMAL
        self.preferences['FontStyle']               = wx.FONTSTYLE_NORMAL
        self.preferences['NotebookStyle']           = 'FlatNoteBook'
        self.preferences['UserEnzymesName']         = "Favourites"
        self.preferences['UserEnzymes']             = []
        self.preferences['UseToolBar']              = True
        self.preferences['showEnzymeWarning']       = True
        
        try: 
            tree                                    = ET.parse(self.preferenceFile) 
            root                                    = tree.getroot() 
            for elem in list(root):   
                self.preferences[elem.tag]          = elem.text 
                for child in elem.getchildren(): 
                    self.preferences[child.tag]     = child.text  
        except:
            # If can't read Preferences, stick with defaults 
            #print "Can't read preferences"
            #raise
            pass
            
        #Fix preferences from text to Python objects  
        self.preferences['ExportResolution']        = float( self.preferences['ExportResolution'] ) 
        self.preferences['MinimumORFLength']        = int( self.preferences['MinimumORFLength'] ) 
        
        for key in ['IdentifyOrfText', 'IdentifyOrfGeneBank', 'StartWithATG', 'UseToolBar', 'showEnzymeWarning']: 
            if self.preferences[key] in ("True", True):
                self.preferences[key]               = True
            else:
                self.preferences[key]               = False  
        
        for key in ['UserEnzymes', 'RecentFiles']:    
            if type(self.preferences[key])  == list:
                pass
            if type(self.preferences[key])  == str:
                self.preferences[key]               = self.preferences[key].split(",")
            else:
                self.preferences[key]               = []
        
    def writePreferences(self): 
        try: 
            w = XMLWriter(self.preferenceFile)  
            root = w.start("Preferences") 
            
            for (key, value) in self.preferences.items():
                if key in ['UserEnzymes', 'RecentFiles']:
                    w.element(key,      ",".join(value) )
                else:
                    w.element(key,      str(value) )
                
            w.close(root) 
        except: 
            #pass
            raise
            sys.exit()
        
    def setupToolBar(self): 
        #Set up the toolbar ########################################
        imgPath = os.path.join(pathToResources,'Images/')
        self.toolBar = self.CreateToolBar(wx.TB_BOTTOM|wx.TB_TEXT) 
        printBmp        = wx.Bitmap(os.path.join(imgPath, "print.png"),         wx.BITMAP_TYPE_PNG)
        saveBmp         = wx.Bitmap(os.path.join(imgPath, "save.png"),          wx.BITMAP_TYPE_PNG) 
        circularBmp     = wx.Bitmap(os.path.join(imgPath, "Circular.png"),      wx.BITMAP_TYPE_PNG)
        linearBmp       = wx.Bitmap(os.path.join(imgPath, "Linear.png"),        wx.BITMAP_TYPE_PNG)
        enzymeBmp       = wx.Bitmap(os.path.join(imgPath, "Enzyme.png"),        wx.BITMAP_TYPE_PNG)
        mcsBmp          = wx.Bitmap(os.path.join(imgPath, "MCS.png"),           wx.BITMAP_TYPE_PNG)
        geneBmp         = wx.Bitmap(os.path.join(imgPath, "Gene.png"),          wx.BITMAP_TYPE_PNG)
        copyBmp         = wx.Bitmap(os.path.join(imgPath, "Copy.png"),          wx.BITMAP_TYPE_PNG)
        cutBmp          = wx.Bitmap(os.path.join(imgPath, "Cut.png"),           wx.BITMAP_TYPE_PNG)
        insertBmp       = wx.Bitmap(os.path.join(imgPath, "Insert.png"),        wx.BITMAP_TYPE_PNG)
        listviewBmp     = wx.Bitmap(os.path.join(imgPath, "List.png"),          wx.BITMAP_TYPE_PNG)
        textBmp         = wx.Bitmap(os.path.join(imgPath, "text.png"),          wx.BITMAP_TYPE_PNG)
        infoBmp         = wx.Bitmap(os.path.join(imgPath, "Info.png"),          wx.BITMAP_TYPE_PNG)
        rectBmp         = wx.Bitmap(os.path.join(imgPath, "Rectangle.png"),     wx.BITMAP_TYPE_PNG)
        circleBmp       = wx.Bitmap(os.path.join(imgPath, "Circle.png"),        wx.BITMAP_TYPE_PNG)
        arrowBmp        = wx.Bitmap(os.path.join(imgPath, "Arrow.png"),         wx.BITMAP_TYPE_PNG)

        self.toolBar.AddTool(self.printMenuID,          printBmp,       shortHelpString="Print" )
        self.toolBar.AddTool(self.saveMenuID,           saveBmp,        shortHelpString="Save")
        self.toolBar.AddSeparator()
        self.toolBar.AddTool(self.newPlasmidMenuID,     circularBmp,    shortHelpString="New circular plasmid" )
        self.toolBar.AddTool(self.newLinearMenuID,      linearBmp,      shortHelpString="New linear DNA" )
        self.toolBar.AddSeparator() 
        self.toolBar.AddTool(self.newEnzymeMenuID,      enzymeBmp,      shortHelpString="Add new enzyme")
        self.toolBar.AddTool(self.newMCSMenuID,         mcsBmp,         shortHelpString="Add new MCS")
        self.toolBar.AddTool(self.newGeneMenuID,        geneBmp,        shortHelpString="Add new gene")
        self.toolBar.AddSeparator()
        self.toolBar.AddTool(self.copyFragmentMenuID,   copyBmp,        shortHelpString="Copy")
        self.toolBar.AddTool(self.cutFragmentMenuID,    cutBmp,         shortHelpString="Cut")
        self.toolBar.AddTool(self.insertFragmentMenuID, insertBmp,      shortHelpString="Insert")
        self.toolBar.AddSeparator()
        self.toolBar.AddTool(self.addTextMenuID,        textBmp,        shortHelpString="Add text")
        self.toolBar.AddTool(self.addArrowMenuID,       arrowBmp,       shortHelpString="Add arrow")
        self.toolBar.AddTool(self.addCircleMenuID,      circleBmp,      shortHelpString="Add circle")
        self.toolBar.AddTool(self.addRectangleMenuID,   rectBmp,        shortHelpString="Add box")
        self.toolBar.AddSeparator()
        self.toolBar.AddTool(self.viewAllAsListMenuID,  listviewBmp,    shortHelpString="View as list")
        self.toolBar.AddSeparator()         
        self.scaleSpinCtrl = wx.SpinCtrl(self.toolBar, wx.ID_ANY, value="100", min=10, max=1000, style=wx.SP_ARROW_KEYS  ) 
        self.toolBar.AddControl(self.scaleSpinCtrl)
        self.toolBar.AddSeparator()        
        self.toolBar.AddTool(self.editPlasmidMenuID,    infoBmp,        shortHelpString="Get plasmid info") 
         
        self.toolBar.Realize()
             
    def setMenuIDs(self):
        self.openMenuID                     = wx.NewId()
        self.importMenuID                   = wx.NewId()
        self.importFromGBMenuID             = wx.NewId()
        self.importFromFastAMenuID          = wx.NewId()
        self.importFromEmbossID             = wx.NewId()
        self.openRecentMenuID               = wx.NewId()
        self.clearRecentMenuID              = wx.NewId()
        self.closeMenuID                    = wx.NewId()
        self.saveMenuID                     = wx.NewId()
        self.saveAsMenuID                   = wx.NewId()  
        self.exportMenuID                   = wx.NewId()
        self.importFileMenuID               = wx.NewId()
        self.pageSetupMenuID                = wx.NewId()
        self.printMenuID                    = wx.NewId()
        
        self.undoMenuID                     = wx.NewId()
        self.editPlasmidMenuID              = wx.NewId()
        self.fontMenuID                     = wx.NewId() 
        self.enzymesToMCSMenuID             = wx.NewId() 
        self.deleteMenuID                   = wx.NewId()
        self.editSelectedMenuID             = wx.NewId()
        
        self.newGeneMenuID                  = wx.NewId()
        self.newBatchGeneMenueID            = wx.NewId()
        self.newMCSMenuID                   = wx.NewId()
        self.newEnzymeMenuID                = wx.NewId()
        self.newBatchEnzymeMenuID           = wx.NewId()
        self.insertFragmentMenuID           = wx.NewId() 
        self.cutFragmentMenuID              = wx.NewId()
        self.copyFragmentMenuID             = wx.NewId()
        
        self.addTextMenuID                  = wx.NewId() 
        self.addArrowMenuID                 = wx.NewId() 
        self.addRectangleMenuID             = wx.NewId() 
        self.addCircleMenuID                = wx.NewId() 
        
        self.newPlasmidMenuID               = wx.NewId()
        self.newLinearMenuID                = wx.NewId()
        self.reverseLinearMenuID            = wx.NewId()  
        self.circularizeMenuID              = wx.NewId()  
        self.positionMenuID                 = wx.NewId()
        self.positionEnzymesMenuID          = wx.NewId() 
        self.positionGenesMenuID            = wx.NewId()  
        self.resetMenuID                    = wx.NewId()
        self.resetEnzymesMenuID             = wx.NewId()
        self.resetGenesMenuID               = wx.NewId()
        self.viewAllAsListMenuID            = wx.NewId() 
    
    def enableMenuItems(self, xpcanvas, enable=True): 
        if enable:
            plasmid = xpcanvas.plasmid 
            self.menubar.Enable(self.saveMenuID,                True)
            self.menubar.Enable(self.saveAsMenuID,              True) 
            self.menubar.Enable(self.exportMenuID,              True)
            self.menubar.Enable(self.importFromGBMenuID,        True)
            self.menubar.Enable(self.importFromFastAMenuID,     True)
            self.menubar.Enable(self.exportMenuID,              True) 
            self.menubar.Enable(self.printMenuID,               True) 
            self.menubar.Enable(self.newGeneMenuID,             True)
            #self.menubar.Enable(self.newBatchGeneMenueID,       True)
            #self.menubar.Enable(self.newBatchEnzymeMenuID,      True) 
            self.menubar.Enable(self.newMCSMenuID,              True)
            self.menubar.Enable(self.newEnzymeMenuID,           True)
            self.menubar.Enable(self.fontMenuID,                True)  
            self.menubar.Enable(self.editPlasmidMenuID,         True)
            self.menubar.Enable(self.deleteMenuID,              True)
            self.menubar.Enable(self.editSelectedMenuID,        True) 
            self.menubar.Enable(self.insertFragmentMenuID,      True)
            self.menubar.Enable(self.cutFragmentMenuID,         True) 
            self.menubar.Enable(self.copyFragmentMenuID,        True)
            self.menubar.Enable(self.addTextMenuID,             True)
            self.menubar.Enable(self.addArrowMenuID,            True)
            self.menubar.Enable(self.addRectangleMenuID,        True)
            self.menubar.Enable(self.addCircleMenuID,           True)
            self.menubar.Enable(self.viewAllAsListMenuID,       True)
            self.menubar.Enable(self.positionMenuID,            True) 
            self.menubar.Enable(self.positionEnzymesMenuID,     True) 
            self.menubar.Enable(self.positionGenesMenuID,       True) 
            self.menubar.Enable(self.resetMenuID,               True) 
            self.menubar.Enable(self.resetEnzymesMenuID,        True) 
            self.menubar.Enable(self.resetGenesMenuID,          True)  
            self.menubar.Enable(self.circularizeMenuID,         True)  
            if plasmid['Kind'] == "Linear":
                self.menubar.Enable(self.reverseLinearMenuID,   True) 
            else:
                self.menubar.Enable(self.reverseLinearMenuID,   False)  
                
            if hasattr(self, 'toolbar'):            
                self.toolBar.EnableTool(self.saveMenuID,            True)
                self.toolBar.EnableTool(self.printMenuID,           True)
                self.toolBar.EnableTool(self.newEnzymeMenuID,       True)
                self.toolBar.EnableTool(self.newMCSMenuID,          True)
                self.toolBar.EnableTool(self.newGeneMenuID,         True)
                self.toolBar.EnableTool(self.copyFragmentMenuID,    True)
                self.toolBar.EnableTool(self.cutFragmentMenuID,     True)
                self.toolBar.EnableTool(self.insertFragmentMenuID,  True)
                self.toolBar.EnableTool(self.viewAllAsListMenuID,   True)
                self.toolBar.EnableTool(self.addTextMenuID,         True) 
                self.toolBar.EnableTool(self.addArrowMenuID,        True) 
                self.toolBar.EnableTool(self.addCircleMenuID,       True) 
                self.toolBar.EnableTool(self.addRectangleMenuID,    True) 
        else: 
            self.menubar.Enable(self.saveMenuID,                False)
            self.menubar.Enable(self.saveAsMenuID,              False) 
            self.menubar.Enable(self.exportMenuID,              False)  
            self.menubar.Enable(self.printMenuID,               False)  
            self.menubar.Enable(self.undoMenuID,                False)
            self.menubar.Enable(self.newGeneMenuID,             False)
            #self.menubar.Enable(self.newBatchGeneMenueID,       False) 
            #self.menubar.Enable(self.newBatchEnzymeMenuID,      False)
            self.menubar.Enable(self.newMCSMenuID,              False)
            self.menubar.Enable(self.newEnzymeMenuID,           False)
            self.menubar.Enable(self.resetMenuID,               False)
            self.menubar.Enable(self.fontMenuID,                False) 
            self.menubar.Enable(self.editPlasmidMenuID,         False)
            self.menubar.Enable(self.deleteMenuID,              False)
            self.menubar.Enable(self.editSelectedMenuID,        False) 
            self.menubar.Enable(self.insertFragmentMenuID,      False)
            self.menubar.Enable(self.cutFragmentMenuID,         False) 
            self.menubar.Enable(self.copyFragmentMenuID,        False)
            self.menubar.Enable(self.addTextMenuID,             False)
            self.menubar.Enable(self.addArrowMenuID,            False)
            self.menubar.Enable(self.addRectangleMenuID,        False)
            self.menubar.Enable(self.addCircleMenuID,           False)
            self.menubar.Enable(self.viewAllAsListMenuID,       False) 
            self.menubar.Enable(self.viewAllAsListMenuID,       False)
            self.menubar.Enable(self.positionMenuID,            False)
            self.menubar.Enable(self.positionEnzymesMenuID,     False) 
            self.menubar.Enable(self.positionGenesMenuID,       False)
            self.menubar.Enable(self.resetMenuID,               False) 
            self.menubar.Enable(self.resetEnzymesMenuID,        False) 
            self.menubar.Enable(self.resetGenesMenuID,          False)   
            self.menubar.Enable(self.reverseLinearMenuID,       False)
            self.menubar.Enable(self.circularizeMenuID,         False) 
            self.menubar.Enable(self.enzymesToMCSMenuID,        False)      # Enabled when enzymes selected 
                        
            if hasattr(self, 'toolbar'):            
                self.toolBar.EnableTool(self.saveMenuID,            False)
                self.toolBar.EnableTool(self.printMenuID,           False)
                self.toolBar.EnableTool(self.newEnzymeMenuID,       False)
                self.toolBar.EnableTool(self.newMCSMenuID,          False)
                self.toolBar.EnableTool(self.newGeneMenuID,         False)
                self.toolBar.EnableTool(self.copyFragmentMenuID,    False)
                self.toolBar.EnableTool(self.cutFragmentMenuID,     False)
                self.toolBar.EnableTool(self.insertFragmentMenuID,  False)
                self.toolBar.EnableTool(self.viewAllAsListMenuID,   False)
                self.toolBar.EnableTool(self.addTextMenuID,         False)  
                self.toolBar.EnableTool(self.addArrowMenuID,        False) 
                self.toolBar.EnableTool(self.addCircleMenuID,       False) 
                self.toolBar.EnableTool(self.addRectangleMenuID,    False) 
            
    def onSetScale(self, evt):
        self.scale = self.scaleSpinCtrl.GetValue()  
        try:
            xpcanvas = self.tabView.GetCurrentPage()
            xpcanvas.setScale(self.scale)
            xpcanvas.Refresh()
        except:
            pass
        
    def setScaleDisplay(self,scale):
        #tabView gets scale from xpcanvas when page changes
        #change the SpinCtrl to reflect the map's scale
        self.scaleSpinCtrl.SetValue(scale * 100)
            
    
    #Menu handlers    
    #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        
    def onPreferences(self,evt): 
        xpcanvas = self.tabView.GetCurrentPage() 
        preferencesDialog = PreferencesDialog(self, xpcanvas)
        preferencesDialog.ShowModal()
        preferencesDialog.Destroy()
        self.readPreferences()
        self.defaultFont = wx.Font( pointSize=int(self.preferences["FontPointSize"]), 
                                    style=int(self.preferences["FontStyle"] ), 
                                    weight=int(self.preferences["FontWeight"] ), 
                                    face=self.preferences["FontFaceName"],
                                    family=wx.FONTFAMILY_DEFAULT  )  
        if xpcanvas != None:
            xpcanvas.defaultFont = self.defaultFont
            xpcanvas.Refresh()
            
    #System menu handlers
    def onQuit(self,evt):    
        shouldQuit = True 
        unsavedPageList = []
        for pageNumber in range( self.tabView.GetPageCount() ):
            page = self.tabView.GetPage(pageNumber)
            if self.unsavedChangesDict[page]:
                unsavedPageList.append(page)
        if len(unsavedPageList) >= 1:  
            if len(unsavedPageList) == 1:
                plasmid = unsavedPageList[0].getPlasmid()
                unsavedError = UnsavedFileWarning(parent=self, frame=self, resources=pathToResources)
                unsavedError.setFileName(plasmid['Name'])
            else:
                unsavedError = UnsavedFilesWarning(parent=self, frame=self, resources=pathToResources)
            response = unsavedError.ShowModal() 
            if response == wx.ID_SAVE:
                for pageNumber in range( self.tabView.GetPageCount() ):
                    #SetSelection is deprecated for Notebooks, but ChangeSelection doesn't seem to work for FlatNotebook
                    self.tabView.SetSelection(pageNumber)
                    xpcanvas = self.tabView.GetCurrentPage()  
                    if self.unsavedChangesDict[xpcanvas]:
                        self.onSaveFile(evt) 
                shouldQuit = True
            elif response == wx.ID_OK:
                shouldQuit = True
            elif response == wx.ID_CANCEL:
                shouldQuit = False 
        if shouldQuit:
            self.preferences['UseToolBar'] = self.useToolBar 
            self.writePreferences()
            if hasattr(self,"listViewFrame"):
                try:
                    self.listViewFrame.Destroy()
                except wx.PyDeadObjectError:
                    pass
                #except:
                #    raise
            self.Destroy() 
            
    #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    #File menu handlers 
        
    def getNewPlasmidInfo(self, evt):     
        xpcanvas                = XPCanvas(self.tabView,frame=self) 
        if evt.GetId() == self.newPlasmidMenuID:
            newPlasmidDialog    = CircularPlasmidDialog(self, xpcanvas=xpcanvas)
        elif evt.GetId() == self.newLinearMenuID:  
            newPlasmidDialog    = LinearPlasmidDialog(self, xpcanvas=xpcanvas, copied=self.fragment) 
        newPlasmidDialog.ShowModal()  
        try:
            newPlasmidDialog.Destroy()  
        except wx.PyDeadObjectError:
            pass
        plasmid                 = xpcanvas.plasmid  
        if plasmid:
            self.unsavedChangesDict[xpcanvas] = True 
            if len(plasmid['Name']) > 18:
                tabText         = plasmid['Name'][:16] + "..."
            else:
                tabText         = plasmid['Name']
            self.tabView.AddPage(xpcanvas,text=tabText,select=True)  
            self.enableMenuItems(xpcanvas) 
        
    def onReverseLinear(self,evt):
        xpcanvas                = self.tabView.GetCurrentPage()  
        newxpcanvas             = XPCanvas(self.tabView,frame=self) 
        reversePlasmid          = xpcanvas.plasmid.copy() 
        newxpcanvas.setPlasmid(reversePlasmid)
        reversePlasmid['Name']  = reversePlasmid['Name'] + " (Reversed)" 
            
        if len(reversePlasmid['Name']) > 18:
            tabText = reversePlasmid['Name'][:16] + "..."
        else:
            tabText = reversePlasmid['Name']
        self.tabView.AddPage(newxpcanvas,text = tabText,select=True)  
        
        rGenes                  = []
        rMCSList                = []
        rEnzymes                = []   
        
        for gene in xpcanvas.genes: 
            newGene             = gene.copy() 
            newGene["UID"]      = mx.UID.UID()
            newGene["TextUID"]  = mx.UID.UID()
            rGenes.append(newGene)
            
        for mcs in xpcanvas.mcsList:
            newMCS              = mcs.copy()
            newMCS["UID"]       = mx.UID.UID()
            rMCSList.append(newMCS)
            
        for enzyme in xpcanvas.enzymes:
            newEnzyme           = enzyme.copy()
            newEnzyme["UID"]    = mx.UID.UID()
            rEnzymes.append(newEnzyme)
        
        for features in (newxpcanvas.reverseLinear(reversePlasmid['Size'], rGenes, rMCSList, rEnzymes) ):  
            for feature in features: 
                newxpcanvas.setNewFeature(feature) 

        newxpcanvas.description = xpcanvas.description  
        newxpcanvas.description["UID"] =  mx.UID.UID()
        
        newxpcanvas.featuresByUID[newxpcanvas.description["UID"]] = newxpcanvas.description  
                
        self.enableMenuItems(newxpcanvas)  
        self.unsavedChangesDict[newxpcanvas] = False
        newxpcanvas.Refresh()  
        
    def onCircularize(self, evt):
        xpcanvas = self.tabView.GetCurrentPage()  
        xpcanvas.circularize()
        self.toggleUndoMenu()   
        self.toggleLinearMenu()
        
    def onPositionEnzymes(self, evt):
        xpcanvas = self.tabView.GetCurrentPage() 
        if xpcanvas.plasmid["Kind"] in ("Circular", "Plasmid"):
            xpcanvas.positionEnzymesCircular()
        else:
            xpcanvas.positionEnzymesLinear()

    def onPositionGenes(self, evt):
        xpcanvas = self.tabView.GetCurrentPage() 
        if xpcanvas.plasmid["Kind"] == "Linear":
            xpcanvas.positionGenesLinear()
        else: 
            response = wx.MessageBox( message="Sorry, autopositioning gene text doesn't work on circular DNA yet",
                                      caption="Can't auto-position gene text",
                                      style=wx.CANCEL)
 
        
    def onEnzymesToMCS(self, evt):
        xpcanvas = self.tabView.GetCurrentPage()  
        xpcanvas.enzymesToFromMCS()
        self.toggleUndoMenu()     
            
    def toggleLinearMenu(self):  
        xpcanvas = self.tabView.GetCurrentPage() 
        plasmid = xpcanvas.plasmid 
        if plasmid['Kind'] == "Linear":
            self.menubar.Enable(self.reverseLinearMenuID,   True)  
            self.positionMenu.Enable(self.positionGenesMenuID,   True) 
        else:
            self.menubar.Enable(self.reverseLinearMenuID,   False) 
            self.positionMenu.Enable(self.positionGenesMenuID,   False)  
        
    def onRecentFile(self,evt):
        fileName = self.recentFilesFileById[ evt.GetId() ]     
        self.openXMLFile(fileName) 
        
    def setUpRecentFiles(self): 
        if len(self.preferences['RecentFiles']) > 0: 
            for fileName in self.preferences['RecentFiles']: 
                id                                  = wx.NewId()
                self.recentFilesIdByFile[fileName]  = id
                self.recentFilesFileById[id]        = fileName
                displayName                         = os.path.split(fileName)[1]
                self.recentFilesMenu.Insert(0, self.recentFilesIdByFile[fileName], displayName) 
        
    def clearRecentFiles(self, evt): 
        for i in range(len(self.preferences['RecentFiles'])-1, -1, -1): 
            deleteFile = self.preferences['RecentFiles'][i]
            deleteId = self.recentFilesIdByFile[deleteFile]
            self.recentFilesMenu.Delete(deleteId)
            
        self.preferences['RecentFiles'] = [] 
        #self.setUpRecentFiles()
        #self.Refresh()
        
    def onOpenFile(self,evt): 
        """On 'Open' menu item 
        Get the path to the file to open
        Enable menus 
        pass fileName to openXMLFile"""
        openDialog = wx.FileDialog( self, 
                                    message="Open a plasmid file:", 
                                    defaultDir="", 
                                    defaultFile="",  
                                    style=wx.OPEN | wx.FD_CHANGE_DIR)
         
        if openDialog.ShowModal() == wx.ID_OK:
            fileNames = openDialog.GetPaths()  
            openDialog.Destroy()   
            
            for fileName in fileNames:
                self.openXMLFile(fileName) 
        else: 
            openDialog.Destroy() 
            
    def openXMLFile(self, fileName):  
        """Read plasmid info stored as XML file (.xpmp extension)
        fileName is passed from onOpenFile
        Set a new unique ID from mx.UID.UID()
        Load the XML file info into plasmid, gene, enzyme, and MCS dictionaries"""
        try:     
            xpcanvas                            = XPCanvas(self.tabView,frame=self)   
            tree                                = ET.parse(fileName) 
            root                                = tree.getroot() 
            plasmid                             = {}
            for elem in list(root):  
                if elem.tag     == "plasmid": 
                    newPlasmid                  = Plasmid(xpcanvas=xpcanvas )
                    newPlasmid.fromXML(elem)
                    plasmid                     = newPlasmid.asDict()
                    plasmid["UID"]              = mx.UID.UID()
                    xpcanvas.setPlasmid(plasmid)
                    xpcanvas.getSize(None)
                    
                elif elem.tag   == "gene":
                    newGene                     = Gene(xpcanvas=xpcanvas )
                    newGene.fromXML(elem)
                    gene                        = newGene.asDict()
                    gene["UID"]                 = mx.UID.UID()
                    xpcanvas.setGenes(gene) 
                    
                elif elem.tag   == "enzyme":
                    newEnzyme                   = Enzyme(xpcanvas=xpcanvas )
                    newEnzyme.fromXML(elem)
                    enzyme                      = newEnzyme.asDict()
                    enzyme["UID"]               = mx.UID.UID()
                    xpcanvas.setEnzymes(enzyme) 
                    
                elif elem.tag   == "mcs":
                    newMCS                      = MCS(xpcanvas=xpcanvas )
                    newMCS.fromXML(elem)
                    mcs                         = newMCS.asDict()
                    mcs["UID"]                  = mx.UID.UID()
                    xpcanvas.setMCSList(mcs) 
                    
                elif elem.tag   == "comment":
                    newComment                  = Comment(xpcanvas=xpcanvas )
                    newComment.fromXML(elem)
                    comment                     = newComment.asDict() 
                    comment["UID"]              = mx.UID.UID() 
                    xpcanvas.setComments(comment)  
                    
                elif elem.tag == "shape":
                    newShape                    = Shape( )
                    newShape.fromXML(elem)
                    shape                       = newShape.asDict()  
                    shape["UID"]                = mx.UID.UID()
                    xpcanvas.setShapes(shape)   
                    
                elif elem.tag == "Description": 
                    newText                     = Text(xpcanvas=xpcanvas )
                    newText.fromXML(elem) 
                    description                 = newText.asDict() 
                    description["UID"]          = mx.UID.UID()
                     
                    xpcanvas.description        = description  
                    xpcanvas.featuresByUID[description['UID']]  = xpcanvas.description 
                    
            if not xpcanvas.description:
                # Converting an old-style file with fixed description,
                # to a new style with movable position
                descr                               = Text(xpcanvas)
                xpcanvas.description                = descr.default()
                xpcanvas.description["Kind"]        = "Description" 
                xpcanvas.description["Position"]    = False
                xpcanvas.featuresByUID[xpcanvas.description['UID']] = xpcanvas.description
                
            
            #Add the map to the notebook and update the list view 
            xpcanvas.setFileName(fileName)  
            if plasmid['Name'] in ( "", None):
                plasmid['Name']                 = ""
                tabText                         = "Unnamed map"
            elif len(plasmid['Name']) > 18:
                tabText                         = plasmid['Name'][:18]
            else:
                tabText                         = plasmid['Name']
            self.tabView.AddPage(xpcanvas, text=tabText, select=True)  
            xpcanvas.Refresh()   
            self.refreshListCtrl()   
            
            # Update "Open recent ... " submenu
            # Commas in the file name will break recentfiles when reading preferences
            if fileName not in self.preferences['RecentFiles'] and "," not in fileName:
                tempID = wx.NewId()
                self.recentFilesIdByFile[fileName]  = tempID
                self.recentFilesFileById[tempID]    = fileName
                self.preferences['RecentFiles'].append(fileName)
                displayName                         = os.path.split(fileName)[1]
                self.recentFilesMenu.Insert(0,tempID, displayName)   
                self.Bind(wx.EVT_MENU,  self.onRecentFile,  id=tempID )
                if len(self.preferences['RecentFiles']) > 10:
                    deleteFile                      = self.preferences['RecentFiles'].pop(0)
                    deleteId                        = self.recentFilesIdByFile[deleteFile]
                    self.recentFilesMenu.Delete(deleteId) 
             
            self.enableMenuItems(xpcanvas)  
            self.unsavedChangesDict[xpcanvas] = False
            
        except IOError: 
            response = wx.MessageBox( message="""Can't find file "%s" """ % fileName,
                                      caption="Unable to read file",
                                      style=wx.CANCEL)
        except expat.ExpatError:
            fileError = CantReadFileError(self, frame=self, resources=pathToResources)
            fileError.setFileName(fileName)
            response = fileError.ShowModal()
        except: 
            response = wx.MessageBox( message="""Problem loading file "%s"\n\nError message: %s """ % (fileName, sys.exc_info()[1]), 
                                      caption="Unable to read file",
                                      style=wx.CANCEL) 
            raise
            
    def onImportFile(self, evt):
        importDialog    = ImportDialog(self)
        response = importDialog.ShowModal()
        if response == wx.ID_CANCEL:
            pass
        elif response == wx.ID_OK:
            pass
        else:
            pass
    
    def importFromGB(self, evt): 
        openDialog = wx.FileDialog( self, 
                                    message="""Import a DNA sequence file in GenBank (".gb") format:""", 
                                    defaultDir="", 
                                    defaultFile="",  
                                    style=wx.OPEN | wx.FD_CHANGE_DIR )
        
        if openDialog.ShowModal() == wx.ID_OK:
            filePaths = openDialog.GetPaths()  
            openDialog.Destroy()  
            for filePath in filePaths:
                self.openGBFile(filePath) 
        else: 
            openDialog.Destroy() 
            
    def importFromFastA(self, evt): 
        openDialog = wx.FileDialog( self, 
                                    message="""Import a DNA sequence file in FastA or plain text format:""", 
                                    defaultDir="", 
                                    defaultFile="",  
                                    style=wx.OPEN | wx.FD_CHANGE_DIR)
                                    
        if openDialog.ShowModal() == wx.ID_OK:
            filePaths = openDialog.GetPaths()  
            openDialog.Destroy()   
            for filePath in filePaths:
                self.openFastAFile(filePath) 
        else: 
            openDialog.Destroy()
        
    def importFromEmboss(self, evt):
        openDialog = wx.FileDialog( self, 
                                    message="""Import a file in EMBOSS (cirdna or lindna) format:""", 
                                    defaultDir="", 
                                    defaultFile="",  
                                    style=wx.OPEN | wx.FD_CHANGE_DIR)
                                    
        if openDialog.ShowModal() == wx.ID_OK:
            filePaths = openDialog.GetPaths()  
            openDialog.Destroy()   
            for filePath in filePaths:
                self.openEmbossFile(filePath) 
        else: 
            openDialog.Destroy()
        
    
    def openGBFile(self, filePath):    
        xpcanvas = XPCanvas(self.tabView, frame=self)  
        
        # Parse a GenBank file using BioPython's GenBank module  
        gbImport            = GenBankImporter(filePath, xpcanvas)
        xpcanvas.plasmid    = gbImport.getHeaderInfo()  
        try:  
            if xpcanvas.plasmid == wx.ID_ABORT:
                raise Exception(">>GenBank import failed: Could not get header info")
            
            newPlasmidDialog    = GBImportedDNADialog(self, xpcanvas=xpcanvas )
            response            = newPlasmidDialog.ShowModal() 
            if response == wx.ID_OK:  
                xpcanvas.Refresh()
                
                plasmid         = xpcanvas.plasmid 
                if plasmid:
                    self.unsavedChangesDict[xpcanvas] = True
                    if len(plasmid['Name']) > 18:
                        tabText = plasmid['Name'][:16] + "..."
                    else:
                        tabText = plasmid['Name']
                    self.tabView.AddPage(xpcanvas,  text=tabText,   select=True)   
                    self.enableMenuItems(xpcanvas) 
                 
                featureList = gbImport.getFeatureInfo()  
                if featureList == wx.ID_ABORT:
                    raise Exception(">>GenBank import failed: Could not get feature info")
                
                # If set in preferences or in identifyORFs checkbox in dialog, 
                # identify open reading frames and add to feature list 
                if self.identifyORFs:  
                    cwORFs      = gbImport.getORFs(gbImport.sequence, self.preferences["MinimumORFLength"], self.preferences['StartWithATG'])
                    comp        = gbImport.reverseSequence(gbImport.sequence)
                    ccwORFs     = gbImport.getORFs(comp, self.preferences["MinimumORFLength"], self.preferences['StartWithATG'], cw=False)
                    featureList.extend(cwORFs)
                    featureList.extend(ccwORFs)
                    
                #Call ImportListView to choose which features to import 
                self.importListView = ImportListView(parent=self,
                                                     size=(self.windowWidth,self.windowHeight-50), 
                                                     tabView=self.tabView, 
                                                     xpcanvas=xpcanvas, 
                                                     features=featureList,
                                                     sequence=gbImport.sequence ) 
                self.importListView.Show()  
        
            elif response == wx.ID_ABORT:
                raise Exception(">>GenBank import failed: Plasmid dialog returned ABORT")
        except: 
            #raise
            errorMsg = GBImportErrorMSG(self, frame=self, resources=pathToResources)
            errorMsg.setFileName(filePath)
            response = errorMsg.ShowModal()
            
                                      
    def openFastAFile(self, filePath): 
        xpcanvas            = XPCanvas(self.tabView, frame=self) 
        
        fastaImport         = FastAImporter(filePath, xpcanvas)
        response            = fastaImport.getFastaInfo() 
        
        if response == wx.ID_OK:  
            plasmid             = xpcanvas.plasmid  
            newPlasmidDialog    = FastAImportedDNADialog(self, xpcanvas=xpcanvas )
            response            = newPlasmidDialog.ShowModal()  
            if plasmid:
                self.unsavedChangesDict[xpcanvas] = True
                if len(plasmid['Name']) > 18:
                    tabText = plasmid['Name'][:16] + "..."
                else:
                    tabText = plasmid['Name']
                self.tabView.AddPage(xpcanvas,  text=tabText,   select=True)   
                self.enableMenuItems(xpcanvas) 
            
            # If set in preferences or in identifyORFs checkbox in dialog, 
            # identify open reading frames and add to feature list 
            featureList     = []
            if self.identifyORFs:  
                cwORFs      = fastaImport.getORFs(fastaImport.sequence, self.preferences["MinimumORFLength"], self.preferences['StartWithATG'])
                comp        = fastaImport.reverseSequence(fastaImport.sequence)
                ccwORFs     = fastaImport.getORFs(comp, self.preferences["MinimumORFLength"], self.preferences['StartWithATG'], cw=False)
                featureList.extend(cwORFs)
                featureList.extend(ccwORFs)
                
                #Call ImportListView to choose which features to import 
                self.importListView = ImportListView(parent=self,
                                                 size=(self.windowWidth,self.windowHeight-50), 
                                                 tabView=self.tabView, 
                                                 xpcanvas=xpcanvas, 
                                                 features=featureList,
                                                 sequence=fastaImport.sequence ) 
                self.importListView.Show()  
    
    def openEmbossFile(self, filePath):
        xpcanvas            = XPCanvas(self.tabView, frame=self)  
        embossImport        = EmbossImporter(filePath)
        response            = embossImport.getSize()
        if response == wx.ID_OK:  
            dna             = Plasmid( xpcanvas )
            dna.newFromDict(dna.default() ) 
            fileName        = os.path.split(filePath)[-1]
            dna.name        = fileName
            dna.size        = embossImport.DNASize  
            # There seems to be no simple way to distinguish circular vs. linear DNA from file info
            # Assume the DNA is circular 
            dna.kind        = "Circular" 
            xpcanvas.setPlasmid(dna.asDict() )  
            
            com             = Comment(xpcanvas)
            # Eventually work directly with Comment
            comment         = com.default()
            comment["Text"] = "Imported from EMBOSS file %s" % (fileName) 
            xpcanvas.setComments(comment) 
            
            descr                               = Text(xpcanvas)
            xpcanvas.description                = descr.default()
            xpcanvas.description["Kind"]        = "Description" 
            xpcanvas.description["Position"]    = False
            xpcanvas.featuresByUID[xpcanvas.description['UID']] = xpcanvas.description
            
            self.unsavedChangesDict[xpcanvas] = True
            if len(dna.name) > 18:
                tabText     = dna.name[:16] + "..."
            else:
                tabText     = dna.name
            self.tabView.AddPage(xpcanvas,  text=tabText,   select=True)   
            self.enableMenuItems(xpcanvas) 
        if response == wx.ID_ABORT:
            # # # Call warning dialog
            print "PROBLEMS GETTING FILE INFO" 
        
        response            = embossImport.getFeatures()
        if response == wx.ID_OK:  
            for feature in embossImport.features:
                # feature = (blockStart, blockEnd, blockColor, blockName)
                gene        = Gene(xpcanvas)
                gene.newFromDict(gene.default() )
                gene.start  = feature[0]
                gene.end    = feature[1]
                gene.color  = feature[2]
                gene.name   = feature[3]
                xpcanvas.setGenes(gene.asDict() ) 
                
            for enzyme in embossImport.enzymes: 
                enz         = Enzyme(xpcanvas)
                enz.newFromDict(enz.default() )
                enz.location    = enzyme[0] 
                enz.name    = enzyme[1]  
                xpcanvas.setEnzymes(enz.asDict() )
        if response == wx.ID_ABORT:
            # # # Call warning dialog
            print "PROBLEMS GETTING FILE INFO"  
        
    
    def onClosePage(self,evt):    
        if self.activeWindow.GetName() == "BaseFrame":
            index = self.tabView.GetSelection() 
            if index < 0:
                self.onQuit(evt)
            else: 
                xpcanvas = self.tabView.GetCurrentPage()  
                if self.unsavedChangesDict[xpcanvas]:
                    plasmid = xpcanvas.plasmid
                    name = plasmid['Name']
                    unsavedError = UnsavedFileWarning(parent=self, frame=self, resources=pathToResources)
                    unsavedError.setFileName(name)
                    response = unsavedError.ShowModal() 
                    if response == wx.ID_SAVE:
                        self.onSaveFile(evt) 
                        self.tabView.DeletePage(index) 
                    elif response == wx.ID_OK:
                        self.tabView.DeletePage(index)
                    elif response == wx.ID_CANCEL:
                        pass
                else:                
                    self.tabView.DeletePage(index)  
        else:
            self.activeWindow.Close()
            
    def setUnsavedChanges(self, changes):
        xpcanvas = self.tabView.GetCurrentPage()  
        self.unsavedChangesDict[xpcanvas] = changes 
            
    def onSaveFile(self,evt, xpcanvas=False): 
        if not xpcanvas:
            xpcanvas = self.tabView.GetCurrentPage() 

        #if the page already has a file associated with it, save without asking for a file
        if xpcanvas.getFileName(): 
            self.writeXMLFile(xpcanvas.getFileName())
        elif len(sys.argv) > 1:
            fileName = sys.argv[1] 
        else:
            self.onSaveAs(evt)
            
    def onSaveAs(self,evt): 
        """Get a file path to save plasmid map info as XML
           Then pass that path to saveAs XML """
        xpcanvas = self.tabView.GetCurrentPage() 

        defaultFileName = xpcanvas.plasmid['Name'] + ".xpmp"
        saveDialog = wx.FileDialog(self, message="Save as:", defaultDir="", defaultFile=defaultFileName, 
        wildcard="XPlasMap XML (*.xpmp) |*.xpmp", style=wx.SAVE | wx.FD_OVERWRITE_PROMPT | wx.FD_CHANGE_DIR) 
        if saveDialog.ShowModal()==wx.ID_OK:
            fileName=saveDialog.GetPath()   
            saveDialog.Destroy()    
            self.writeXMLFile(fileName) 
        else: 
            saveDialog.Destroy()  
            
    def onExportMenu(self, evt):
        xpcanvas = self.tabView.GetCurrentPage()  
        exportDialog = ExportDialog(self, xpcanvas=xpcanvas, defaultRes=self.preferences['ExportResolution'] )
        response = exportDialog.ShowModal()
        if response == wx.ID_CANCEL:
            exportDialog.Destroy()
        elif response == 1: 
            self.onSaveAsJPG()
        elif response == 2:
            self.onSaveAsPNG()
        elif response == 3:
            self.onSaveAsText()
        
    def setExportResolution(self, res):
        self.exportResolution = res
        
    def onSaveAsPNG(self):
        exportScale = self.exportResolution
        xpcanvas = self.tabView.GetCurrentPage()  
        oldScale = xpcanvas.getScale()
        xpcanvas.setScale(exportScale * 100.0)
        (width, height) = xpcanvas.GetSizeTuple()
        bitmap = wx.EmptyBitmap(width * exportScale, height * exportScale )
        memoryDC = wx.MemoryDC(bitmap)   
        memoryDC.SetUserScale(exportScale, exportScale)
        xpcanvas.doDrawing(memoryDC)  
        xpcanvas.setScale(oldScale[0] * 100.0)
        saveDialog = wx.FileDialog(self, message="Save as:", defaultDir="", defaultFile=xpcanvas.plasmid['Name'] + ".PNG", 
        wildcard=".PNG", style=wx.SAVE | wx.FD_OVERWRITE_PROMPT | wx.FD_CHANGE_DIR) 
        if saveDialog.ShowModal() == wx.ID_OK:
            fileName = saveDialog.GetPath()  
            saveDialog.Destroy()  
            bitmap.SaveFile(fileName, wx.BITMAP_TYPE_PNG)
        else: 
            saveDialog.Destroy()       
    
    def onSaveAsJPG(self):
        exportScale = self.exportResolution
        xpcanvas = self.tabView.GetCurrentPage()  
        oldScale = xpcanvas.getScale()
        xpcanvas.setScale(exportScale * 100.0)
        (width, height) = xpcanvas.GetSizeTuple()
        bitmap = wx.EmptyBitmap(width * exportScale, height * exportScale )
        memoryDC = wx.MemoryDC(bitmap)  
        memoryDC.SetUserScale(exportScale, exportScale)
        memoryDC.SetPen(wx.NullPen ) 
        memoryDC.SetBrush(wx.WHITE_BRUSH)
        memoryDC.DrawRectangle(0, 0, width * exportScale, height * exportScale)
        xpcanvas.doDrawing(memoryDC)   
        xpcanvas.setScale(oldScale[0] * 100.0)
        saveDialog = wx.FileDialog(self, message="Save as:", defaultDir="", defaultFile=xpcanvas.plasmid['Name'] + ".JPG", 
        wildcard=".JPG", style=wx.SAVE | wx.FD_OVERWRITE_PROMPT | wx.FD_CHANGE_DIR) 
        if saveDialog.ShowModal() == wx.ID_OK:
            fileName = saveDialog.GetPath()  
            saveDialog.Destroy()  
            bitmap.SaveFile(fileName, wx.BITMAP_TYPE_JPEG)
        else: 
            saveDialog.Destroy()      
            
    def onSaveAsText(self):  
        xpcanvas = self.tabView.GetCurrentPage()
        saveDialog = wx.FileDialog(self, message="Save as:", defaultDir="", defaultFile=xpcanvas.plasmid['Name'] + ".txt", 
        wildcard=".TXT", style=wx.SAVE | wx.FD_OVERWRITE_PROMPT | wx.FD_CHANGE_DIR) 
        if saveDialog.ShowModal() == wx.ID_OK:
            fileName = saveDialog.GetPath()  
            saveDialog.Destroy()  
            
            mapAsText = self.getMapAsText(xpcanvas) 
            f = file(fileName, "w")
            f.write(mapAsText)
            f.close() 
        else: 
            saveDialog.Destroy()  
    
    def getMapAsText(self, xpcanvas):
        if xpcanvas.plasmid["Kind"] in ("Circular", "Plasmid"):
            type = "Circular"
        else:
            type = "Linear"
        optional = ""
        if xpcanvas.plasmid["MadeBy"] not in (None,  ""):
            optional = optional + "Made by: %s\t" % xpcanvas.plasmid["MadeBy"]
        if xpcanvas.plasmid["Date"]  not in (None,  ""):
            optional = optional + "Date: %s" % xpcanvas.plasmid["Date"]
        mapAsText =  ["Name: %s\tSize: %i bp\tType: %s\n%s" % (xpcanvas.plasmid["Name"], xpcanvas.plasmid["Size"], type, optional)]
 
        geneTemplate = "\t%i-%i:\t%s"
        mcsTemplate = "\t%i-%i:\t%s"
        enzymeTemplate = "\t%i:\t%s"
        commentTemplate = "\t%s" 
        
        mapAsText.append("\nGenes:")
        geneList = [] 
        for gene in xpcanvas.genes:
        
            geneList.append((int(gene["Start"]), geneTemplate % (gene["Start"], gene["End"], gene["Name"]) ) )
        geneList.sort()  
        genes = [x[1] for x in geneList]
        mapAsText.extend(genes) 
        
        mapAsText.append("\nMultiple cloning sites:")
        mcsList = []  
        for mcs in xpcanvas.mcsList:
            mcsList.append((int(mcs["Start"]), mcsTemplate % (mcs["Start"], mcs["End"], mcs["Enzymes"]) ) )
        mcsList.sort()
        mcs = [x[1] for x in mcsList]
        mapAsText.extend(mcs) 
        
        mapAsText.append("\nRestriction enzymes:")
        enzymeList = []  
        for enzyme in xpcanvas.enzymes:
            enzymeList.append((int(enzyme["Location"]), enzymeTemplate % (enzyme["Location"], enzyme["Name"]) ) )
        enzymeList.sort()
        enzymes = [x[1] for x in enzymeList]
        mapAsText.extend(enzymes)
        
        mapAsText.append("\nComments:")
        commentList = []  
        for comment in xpcanvas.comments:
            commentList.append(commentTemplate % comment["Text"])
        commentList.sort()
        mapAsText.extend(commentList) 
        return "\n".join(mapAsText)
        
    def writeXMLFile(self,fileName ):
        """FileName passed from onsaveas
           Use elementtree module to write data as an XML file"""
        w = XMLWriter(fileName)
        xpcanvas = self.tabView.GetCurrentPage() 

        plasmid = xpcanvas.plasmid
        genes = xpcanvas.genes
        mcsList = xpcanvas.mcsList
        enzymes = xpcanvas.enzymes
        comments = xpcanvas.comments 
        try:
            # Save a random number for UIDs 
            # Strictly for compatibility with older versions of XPlasMap
            # which are expecting a float UID on opening a file
            root = w.start("XPlasMap") 
            plasmidXML = w.start("plasmid")
            for (key,value) in plasmid.items(): 
                if key != "UID" :
                    w.element(key,str( value ) ) 
                else:
                    w.element(key,str( random.randrange(0, 1000000 ) ) )
            w.close(plasmidXML)
            for gene in genes:
                geneXML = w.start("gene")
                for (key,value) in gene.items():
                    if key != "UID" and key != "TextUID" :
                        w.element(key,str( value ) ) 
                    else:
                        w.element(key,str( random.randrange(0, 1000000 ) ) )
                w.close(geneXML)
            for mcs in mcsList:
                mcsXML = w.start("mcs")
                for (key,value) in mcs.items():
                    if key != "UID" :
                        w.element(key,str( value ) ) 
                    else:
                        w.element(key,str( random.randrange(0, 1000000 ) ) )
                w.close(mcsXML)
            for enzyme in enzymes:
                enzymeXML = w.start("enzyme")
                for (key,value) in enzyme.items():
                    if key != "UID" :
                        w.element(key,str( value ) ) 
                    else:
                        w.element(key,str( random.randrange(0, 1000000 ) ) )
                w.close(enzymeXML)
            for comment in comments:
                commentXML = w.start("comment")
                for (key,value) in comment.items():
                    if key != "UID" :
                        w.element(key,str( value ) ) 
                    else:
                        w.element(key,str( random.randrange(0, 1000000 ) ) )
                w.close(commentXML)
            for shape in xpcanvas.shapes:
                shapeXML = w.start("shape")
                for (key,value) in shape.items():
                    if key != "UID" :
                        w.element(key,str( value ) ) 
                    else:
                        w.element(key,str( random.randrange(0, 1000000 ) ) )
                w.close(shapeXML)
            
            descriptionXML = w.start("Description")
            for (key,value) in xpcanvas.description.items():
                if key != "UID" :
                    w.element(key,str( value ) ) 
                else:
                    w.element(key,str( random.randrange(0, 1000000 ) ) )
            w.close(descriptionXML)
            
            w.close(root)
        except: 
            response = wx.MessageBox(message="Problem trying to write file:\n%s" % sys.exc_info()[1],
                                     caption="Couldn't save file",
                                     style=wx.OK)
            
        xpcanvas.setFileName(fileName) 
        self.unsavedChangesDict[xpcanvas] = False
        
        #Update "Open recent ... " submenu
        if fileName not in self.preferences['RecentFiles']:
            tempID = wx.NewId()
            self.recentFilesIdByFile[fileName] = tempID
            self.recentFilesFileById[tempID] = fileName
            self.preferences['RecentFiles'].append(fileName)
            displayName = os.path.split(fileName)[1]
            self.recentFilesMenu.Insert(0,tempID, displayName)   
            self.Bind(wx.EVT_MENU,  self.onRecentFile,  id=tempID )
            if len(self.preferences['RecentFiles']) > 10:
                deleteFile = self.preferences['RecentFiles'].pop(0)
                deleteId = self.recentFilesIdByFile[deleteFile]
                self.recentFilesMenu.Delete(deleteId)
            
    def onPageSetup(self,evt):
        xpcanvas = self.tabView.GetCurrentPage() 
        pageSetup = PrintPanel(self, xpcanvas )
        self.printData = pageSetup.OnPageSetup(evt) 
            
    def onPrint(self,evt):   
        xpcanvas = self.tabView.GetCurrentPage()  
        printDialog = PrintPanel(self, xpcanvas, self.printData) 
        printDialog.OnDoPrint(evt) 
        printDialog.Destroy()
     
    #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    #Edit menu handlers  
    
    def onUndo(self, evt): 
        xpcanvas = self.tabView.GetCurrentPage() 
 
        #get the most recent plasmid state 
        undo = xpcanvas.restoreLastChange()
        if undo: 
            (backupPlasmid, backupMCSList, 
                            backupGenes, 
                            backupEnzymes, 
                            backupComments, 
                            backupShapes, 
                            descr)          = undo
            currentMCSList      = copy.copy( xpcanvas.mcsList )
            currentGenes        = copy.copy( xpcanvas.genes )
            currentEnzymes      = copy.copy( xpcanvas.enzymes ) 
            currentComments     = copy.copy( xpcanvas.comments ) 
            currentShapes       = copy.copy( xpcanvas.shapes )  
            xpcanvas.setPlasmid(backupPlasmid, refresh=False)  
            
            for currentGene in currentGenes:
                xpcanvas.deleteGene(currentGene['UID'], backup=False, refresh=False)
            for currentMCS in currentMCSList:
                xpcanvas.deleteMCS(currentMCS['UID'], backup=False, refresh=False) 
            for currentEnzyme in currentEnzymes:
                xpcanvas.deleteEnzyme(currentEnzyme['UID'], backup=False, refresh=False) 
            for currentComment in currentComments:
                xpcanvas.deleteComment(currentComment['UID'], backup=False, refresh=False) 
            for currentShape in currentShapes:
                xpcanvas.deleteShape(currentShape['UID'], backup=False, refresh=False) 
            del xpcanvas.featuresByUID[xpcanvas.description["UID"]]
            
            for gene in backupGenes:
                xpcanvas.setGenes(gene, refresh=False)
            for mcs in backupMCSList:
                xpcanvas.setMCSList(mcs, refresh=False)
            for enzyme in backupEnzymes:
                xpcanvas.setEnzymes(enzyme, refresh=False) 
            for comment in backupComments:
                xpcanvas.setComments(comment, refresh=False) 
            for shape in backupShapes:
                xpcanvas.setShapes(shape, refresh=False) 
            xpcanvas.description = descr  
            xpcanvas.featuresByUID[xpcanvas.description["UID"]] = xpcanvas.description 
            
            self.toggleUndoMenu()  
            self.enableMenuItems(xpcanvas)
            
            xpcanvas.selectedEnzymes                        = []
            self.menubar.Enable(self.enzymesToMCSMenuID,    False) 
            xpcanvas.selected                               = False
            xpcanvas.highlight                              = False
            xpcanvas.Refresh()
            self.refreshListCtrl()
    
    def toggleUndoMenu(self):  
        xpcanvas        = self.tabView.GetCurrentPage()  
        undoListLength  = xpcanvas.getBackupsForUndo()   
        if undoListLength > 0:  
            self.menubar.Enable(self.undoMenuID,    True) 
        else: 
            self.menubar.Enable(self.undoMenuID,    False)  
            
    def onBatchGenes(self, evt):
        xpcanvas = self.tabView.GetCurrentPage() 

        geneBatchDialog = GeneBatchDialog(self, xpcanvas=xpcanvas) 
        success = geneBatchDialog.ShowModal()   
        try:
            geneBatchDialog.Destroy()   
        except wx.PyDeadObjectError:
            pass  
        self.toggleUndoMenu() 
        
    
    def onAddGene(self,evt):  
        xpcanvas = self.tabView.GetCurrentPage() 

        geneDialog=GeneDialog(self, xpcanvas=xpcanvas) 
        geneDialog.ShowModal()   
        try:
            geneDialog.Destroy()   
        except wx.PyDeadObjectError:
            pass  
        self.toggleUndoMenu()  
        
    def onAddMCS(self,evt):
        xpcanvas = self.tabView.GetCurrentPage() 

        mcsDialog=MCSDialog(self,xpcanvas=xpcanvas)
        mcsDialog.ShowModal()    
        try:
            mcsDialog.Destroy()   
        except wx.PyDeadObjectError:
            pass  
        self.toggleUndoMenu()  
        
    def onAddEnzyme(self,evt): 
        xpcanvas = self.tabView.GetCurrentPage()  
        enzymeDialog = EnzymeDialog(self,xpcanvas=xpcanvas)
        success = enzymeDialog.ShowModal()    
        try:
            enzymeDialog.Destroy()   
        except wx.PyDeadObjectError:
            pass  
        self.toggleUndoMenu() 
        
    def onBatchEnzymes(self, evt):
        xpcanvas = self.tabView.GetCurrentPage()  
        enzymeBatchDialog = EnzymeBatchDialog(self, xpcanvas=xpcanvas)
        success = enzymeBatchDialog.ShowModal()    
        try:
            enzymeBatchDialog.Destroy()   
        except wx.PyDeadObjectError:
            pass  
        self.toggleUndoMenu()  
        
    def onReset(self, evt): 
        xpcanvas = self.tabView.GetCurrentPage()   
        self.toggleUndoMenu()    
        
    def onResetEnzymes(self, evt): 
        xpcanvas = self.tabView.GetCurrentPage()  
        xpcanvas.onResetEnzymePositions() 
        self.toggleUndoMenu()   
        
    def onResetGenes(self, evt): 
        xpcanvas = self.tabView.GetCurrentPage()  
        xpcanvas.onResetGenePositions() 
        self.toggleUndoMenu()   
        
    def onDeleteMenu(self, evt):
        xpcanvas = self.tabView.GetCurrentPage()   
        plasmid = xpcanvas.plasmid
        
        if xpcanvas.selectStart and xpcanvas.selectEnd:
            # Start and end of fragment defined by selecting enzymes
            xpcanvas.backupsForUndo() 
            fragment = Fragment(xpcanvas)
            fragment.copyFragmentFromEnzymes(xpcanvas.selectStart, xpcanvas.selectEnd ) 
            fragment.deleteFragment(xpcanvas.selectStart, xpcanvas.selectEnd, "Clockwise")
            self.toggleUndoMenu()   
        else:
            xpcanvas.backupsForUndo()   
            deleteDialog = DeleteDialog( parent=self, 
                                                xpcanvas=xpcanvas, 
                                                plasmid=plasmid)
            response = deleteDialog.ShowModal()   
            if response == wx.ID_OK : 
                self.toggleUndoMenu()  
            else:
                self.onUndo(evt)
                self.toggleUndoMenu()  
        xpcanvas.selectStart    = False
        xpcanvas.selectEnd      = False
        
    def onInsertMenu(self, evt): 
        xpcanvas                    = self.tabView.GetCurrentPage()   
        xpcanvas.backupsForUndo()
        if xpcanvas.selected: 
            if xpcanvas.selected["Kind"] == "Enzyme":
                # An enzyme has been selected; insert fragment at the enzyme location
                insertFragmentDialog = InsertFragmentDialog( parent=self, 
                                                                xpcanvas=xpcanvas,
                                                                copied=self.fragment, 
                                                                location=xpcanvas.selected["Location"] )
            else:
                insertFragmentDialog = InsertFragmentDialog( parent=self,
                                                                xpcanvas=xpcanvas,
                                                                copied=self.fragment )
        else:
            insertFragmentDialog = InsertFragmentDialog( parent=self,
                                                            xpcanvas=xpcanvas,
                                                            copied=self.fragment )  
        response = insertFragmentDialog.ShowModal()  
        if response == wx.ID_CANCEL:
            self.onUndo(evt)   
        self.toggleUndoMenu()   
            

    def onAddText(self,evt):
        xpcanvas = self.tabView.GetCurrentPage()
        xpcanvas.addText()
        
    def onAddArrowMenu(self,evt):
        xpcanvas = self.tabView.GetCurrentPage()
        xpcanvas.addShape(name="Arrow")
        
    def onAddRectangleMenu(self,evt):
        xpcanvas = self.tabView.GetCurrentPage()
        xpcanvas.addShape(name="Rectangle")
        
    def onAddCircleMenu(self,evt): 
        xpcanvas = self.tabView.GetCurrentPage()
        xpcanvas.addShape(name="Circle")

    def copyFragmentMenu(self,evt): 
        xpcanvas = self.tabView.GetCurrentPage()  
        fragment = Fragment(xpcanvas)
        if xpcanvas.selectStart and xpcanvas.selectEnd:
            # If ends are already defined (by selecting enzymes)
            # skip the dialog and just copy the fragment immediately
            fragment.copyFragmentFromEnzymes(xpcanvas.selectStart, xpcanvas.selectEnd)
            xpcanvas.enzyme = False
        else:
            copyFragmentDialog = CopyFragmentDialog(parent=self, xpcanvas=xpcanvas )
            response = copyFragmentDialog.ShowModal() 
        xpcanvas.selectStart                            = False
        xpcanvas.selectEnd                              = False
        xpcanvas.selectedEnzymes                        = []
        self.menubar.Enable(self.enzymesToMCSMenuID,    False)  
        self.toggleUndoMenu() 
        
    def onEditPlasmid(self, evt):
        xpcanvas            = self.tabView.GetCurrentPage() 
        plasmid             = xpcanvas.plasmid
        xpcanvas.backupsForUndo()
        
        if xpcanvas.plasmid["Kind"] == "Linear":
            plasmidDialog   = LinearPlasmidDialog(parent=self, xpcanvas=xpcanvas, editPlasmid=plasmid)
        else:
            plasmidDialog   = CircularPlasmidDialog(parent=self, xpcanvas=xpcanvas, editPlasmid=plasmid)
        response            = plasmidDialog.ShowModal() 
        
        if response == wx.ID_CANCEL:
            self.onUndo(evt)
        else:
            xpcanvas.Refresh()
            self.toggleUndoMenu()   

    def onDeleteSelected(self, evt):
        try:
            xpcanvas = self.tabView.GetCurrentPage()
            xpcanvas.deleteSelected()
        except:
            pass 
    
    def onEditSelected(self, evt): 
        xpcanvas = self.tabView.GetCurrentPage()
        if xpcanvas.selected:   
            if xpcanvas.selected["Kind"]     == "Gene": 
                xpcanvas.onEditGeneMenu(evt) 
            elif xpcanvas.selected["Kind"]   == "MCS": 
                xpcanvas.onEditMCSMenu(evt) 
            elif xpcanvas.selected["Kind"]   == "Enzyme":
                xpcanvas.onEditEnzymeMenu(evt) 
            elif xpcanvas.selected["Kind"]   == "Comment":
                xpcanvas.onEditCommentMenu(evt) 
            elif xpcanvas.selected["Kind"]   == "Shape":
                xpcanvas.onEditShapeMenu(evt) 
            elif sxpcanvas.elected["Kind"]   == "Description":
                xpcanvas.onEditGeneMenu(evt) 
            
        else: 
            response = wx.MessageBox( message="""Please select an object to be edited""",
                                      caption="Nothing selected",
                                      style=wx.CANCEL) 
        
    def onSetFont(self, evt): 
        xpcanvas = self.tabView.GetCurrentPage()
        xpcanvas.backupsForUndo()
        if xpcanvas.selected:
            if xpcanvas.selected["Kind"] == "Shape":
                setFontDlg = SetBatchFontDialog(self, xpcanvas)
            else:
                setFontDlg = SetSelectedFontDialog(self, xpcanvas)
        else:
            setFontDlg = SetBatchFontDialog(self, xpcanvas)
        response = setFontDlg.ShowModal()
        if response == wx.ID_OK:
            setFontDlg.Destroy()
        elif response == wx.ID_CANCEL:
            self.onUndo(evt)
            setFontDlg.Destroy()
        
        self.toggleUndoMenu()   
        xpcanvas.Refresh()
        
    #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    #View menu handlers  
        
    def makeTabView(self, evt): 
        print self.GetChildren()
    
    def makeNewListctrl(self,evt):
        #set height 50 shorter to account for the toolbar
        self.listViewFrame=ListViewFrame(parent=self,size=(self.windowWidth,self.windowHeight-50) , tabView=self.tabView,xpcanvas = self.tabView.GetCurrentPage() ) 
        self.listViewFrame.Show() 
        
    #-------------------------------------------------------------------
   
    def refreshListCtrl(self): 
        if hasattr(self,"listViewFrame"):
            try:
                self.listViewFrame.refreshListCtrl()
            except wx.PyDeadObjectError:
                pass
            except:
                raise  
        
    def getPreferences(self):
        self.readPreferences()
        return (self.preferences, self.preferenceFile)
 
    def setSavedFragment( self, 
                          fragment, 
                          fragmentGenes, 
                          fragmentMCSList, 
                          fragmentEnzymes, 
                          fragmentComments):
        self.fragment           = fragment
        self.fragmentGenes      = fragmentGenes
        self.fragmentMCSList    = fragmentMCSList 
        self.fragmentEnzymes    = fragmentEnzymes 
        self.fragmentComments   = fragmentComments 
 
    def getSavedFragment(self):
        return (self.fragment, 
                self.fragmentGenes, 
                self.fragmentMCSList, 
                self.fragmentEnzymes, 
                self.fragmentComments)
        
    def setStatusText(self,text): 
        if self.preferences['UseToolBar']:
            self.statusBar.SetStatusText(text, 0)
        else:
            self.statusBar.SetStatusText(text, 2)
            
    def setUseToolBar(self, useToolBar):
        self.useToolBar = useToolBar   

    def onAbout(self,evt):
        info = wx.AboutDialogInfo()
        info.Name = "XPlasMap"
        info.Version = "0.96"
        info.Copyright = "(C) 2007 Ian York"
        info.Description = """
 XPlasMap is free for personal use.
 
 Distribution of XPlasMap is allowed and encouraged, but only 
 as a complete package (including any documentation, read-me,
 and copyright files). Use XPlasMap at your own risk. The author 
 is not responsible for any damage, annoyance, or waste of time 
 or materials resulting from the use of XPlasMap or incorrect 
 information provided by XPlasMap.

 XPlasMap was developed by Ian York (iayork@gmail.com), 
 using Python and wx.Python:
    http://www.python.org
    http://www.wxPython.org 

Additional modules used in XPlasMap:
    ElementTree (http://effbot.org/zone/element-index.htm)
    BioPython (http://biopython.org/)
    BioPython uses the eGenix mx extensions for Python
    (http://www.egenix.com/www2002/python/eGenix-mx-Extensions.html)
 
 Thanks to Paul Tomblin and Clive Feather for geometry advice.
 
 Some toolbar icons (the non-lame ones) from Matt Ball's Developer 
 Icons and from the Kombine Group (www.kombine.net).  
 
 Please send feedback to iayork@iayork.com.\n\n"""
 
        info.WebSite = ("http://www.iayork.com//XPlasMap", "XPlasMap home page")
        #info.Developers = [ "Ian York (iayork@gmail.com)" ]

        info.License ="""
Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 
   
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."""

        wx.AboutBox(info)
    
        
    
#----------------------------------------------------------------------
#Printing frameworks 

class Printout(wx.Printout):
    def __init__(self, xpcanvas, printDC): 
        wx.Printout.__init__(self)
        self.xpcanvas = xpcanvas 
        self.margins = ( wx.Point(15,15), wx.Point(15,15) ) 
        
    def HasPage(self, page):
        return page <= self.pageCount

    def GetPageInfo(self): 
        return (1, self.pageCount, 1, self.pageCount) 
        
    def OnPreparePrinting(self):  
        #Make a bitmap the same size as the page pixels
        topLeft, bottomRight = self.margins
        (pageX, pageY) = self.GetPageSizePixels()  
        self.pageWidth = pageX - 2 * topLeft.x 
        self.pageHeight = pageY - 2 * topLeft.y 
        
        (mapWidth, mapHeight) = self.xpcanvas.GetSizeTuple() 
        
        widthScale = float(self.pageWidth)/mapWidth
        heightScale = float(self.pageHeight)/mapHeight
        self.dcScale = min(widthScale, heightScale )   
        self.dcBuffer = wx.EmptyBitmap(self.dcScale * mapWidth, self.dcScale * mapHeight)
        memoryDC = wx.MemoryDC( self.dcBuffer ) 
        #Draw a white background - fix resolution bug in PPC Macs
        memoryDC.SetPen( wx.NullPen ) 
        memoryDC.SetBrush(wx.WHITE_BRUSH)
        memoryDC.DrawRectangle(0, 0, self.dcScale * mapWidth, self.dcScale * mapHeight ) 
        
        memoryDC.SetUserScale(self.dcScale, self.dcScale)
        self.xpcanvas.doDrawing(memoryDC)   
          
        # A map with map scale = 1 should fit on one page  
        (self.mapScaleX, self.mapScaleY) = self.xpcanvas.getScale() 
        printWidth = self.dcScale * self.mapScaleX * mapWidth 
        printHeight = self.dcScale * self.mapScaleY * mapHeight 
        pagesWide = float(printWidth) / self.pageWidth
        pagesHigh = float(printHeight) / self.pageHeight
        self.pageCount = int(ceil(pagesWide) * ceil(pagesHigh) )  
        
        if self.pageCount > 1:
            self.makeBitmapsForPages()
        else:
            self.bitmapsForPages = [self.dcBuffer] 
        
    def makeBitmapsForPages(self): 
        # At a scale of 1 the map fits on 1 page
        # If the map (because of scaling) is too big for one page,
        # break it up into a list of page-sized sections 
        self.bitmapsForPages = [] 
        
        rectWidth = float(self.pageWidth) / self.mapScaleX
        if rectWidth > self.dcBuffer.GetWidth():
            rectWidth = self.dcBuffer.GetWidth()
        rectHeight = float(self.pageHeight) / self.mapScaleY
        if rectHeight > self.dcBuffer.GetHeight():
            rectHeight = self.dcBuffer.GetHeight()
        #We should already have page count but double check here to make sure things all fit
        pagesWide = ceil( self.dcBuffer.GetWidth() / rectWidth )
        pagesHigh = ceil( self.dcBuffer.GetHeight() / rectHeight )
        
        for y in range( int(pagesHigh) ):
            yStart = y * rectHeight
            if yStart + rectHeight > self.dcBuffer.GetHeight():
                yEnd = self.dcBuffer.GetHeight()
            else:
                yEnd = yStart + rectHeight
            for x in range(int( pagesWide) ):
                xStart = x * rectWidth
                if xStart  + rectWidth > self.dcBuffer.GetWidth():
                    xEnd = self.dcBuffer.GetWidth()
                else:
                    xEnd = xStart + rectWidth      
                self.bitmapsForPages.append( self.dcBuffer.GetSubBitmap(wx.Rect(xStart,yStart,xEnd-xStart, yEnd-yStart ) ) )
    
    def OnPrintPage(self, page ):   
        printDC = self.GetDC()  
        printDC.SetUserScale(self.mapScaleX, self.mapScaleY )
        pageBitmap = self.bitmapsForPages[page - 1] 
        printDC.DrawBitmap(pageBitmap, 0 , 0)  
        return True  

#---------------------------------------------------------------------- 

class PrintPanel(wx.Panel):
    def __init__(self, parent,  xpcanvas, printData=False):
        wx.Panel.__init__(self, parent, wx.ID_ANY)   
        self.xpcanvas = xpcanvas 
        self.frame = parent
        if printData:
            self.printData = printData 
        else:
            self.printData = wx.PrintData()
    
    def OnPageSetup(self, evt): 
        psdd = wx.PageSetupDialogData(self.printData)
        psdd.CalculatePaperSizeFromId()
        setupDialog = wx.PageSetupDialog(self, psdd)
        setupDialog.ShowModal() 
        # make a copy of the wx.PrintData  
        printData = wx.PrintData( setupDialog.GetPageSetupDialogData().GetPrintData() )  
        return  printData
        setupDialog.Destroy()
    
    def OnDoPrint(self, event):    
        printout = Printout(self.xpcanvas, self.printData )  
        printout.OnPreparePrinting()  
        if self.printData: 
            data = wx.PrintDialogData(self.printData) 
            printer = wx.Printer(data)
        else:
            printer = wx.Printer()
        printResponse = printer.Print(parent=self.frame, printout=printout, prompt=True) 
        
        if printResponse:
            self.printData = wx.PrintData( printer.GetPrintDialogData().GetPrintData() )
        #else:
        #    wx.MessageBox("Sorry, unable to print", "Problem printing", wx.OK)
        printout.Destroy()  
         

class BaseApp(wx.App):
    def __init__(self):
        wx.App.__init__(self,redirect=False) 
        self.frame = BaseFrame( )
        self.frame.Show()  
        
    def MacOpenFile(self, filename):
        self.frame.openXMLFile(filename)
         
app = BaseApp() #wx.PySimpleApp()
app.MainLoop()